Subject: bug#40626: Poor performance on low-end ARMv7 devices

From: Ludovic Courtès <[email-masked]>
Date: Tue, 14 Jul 2020 15:05:41 +0200

Hi,

Denis 'GNUtoo' Carikli <[email-masked]> skribis:

> A way to deal with that could be to validate if it's actually the case,
> for instance by installing an SSD, and doing performance comparison
> with the time command.
>
> Then if it helps a lot, we probably need to trace the filesystem access
> and optimize it somehow. Maybe that can be done with BPF or gprof, but
> I never looked into obtimizing I/O performances, so I'm unsure if
> that's the right approach. Guile may have profiling tools too.

Yeah, the profiles at <https://issues.guix.gnu.org/40626#5> suggest a
couple of things to investigate in Guile.

> As for benchmarking the CPU, I've patched phoronix-test-suite in a very
> quick and dirty way in Parabola, so we could at least have some
> benchmarks. For now we only have "compilation" benchmarks with source
> code that should be FSDG compliant.
>
> With it I've found that the compilation performances can vary a lot
> between different ARM and x86 boards:
> - An I.MX6 Quad with 2G of RAM is about 4.5x faster than the AM335x of a
>   Beaglebone Green with 512M of RAM.
> - A Lime2 A20 is about 1.7x faster than the Beaglebone Green and 2.5x
>   slower than the board with the I.MX6 Quad.
> - My smartphone (Galaxy SIII GT-I9300) is about 2x faster than my server
>   (PC Engines APU1) for compilation.

Interesting, thanks!

Ludo’.